#ifndef __MISC_H__
#define __MISC_H__

#include "types.h"


const u32 MB = 1 << 20;


#define BIT(n) (1ul << (n))

#ifndef min
#define min(a,b) ((a) < (b)? (a) : (b))
#endif

#ifndef max
#define max(a,b) ((a) < (b)? (b) : (a))
#endif

extern u16 bswap16(u16);
extern u32 bswap32(u32);


/*
 * return -1 if not an integral power of 2,
 *        otherwise the base2 logarithm
 */
extern int log2(const int n);


extern long round_up(long val, int multiple);

extern int ceil(float f);


/*
 * memory freed automatically at exit
 */
extern void* alloc(int size, int align = 1);


extern void* large_malloc(int size);
extern void large_free(void* p);

#endif	/* #ifndef __MISC_H__ */
